package testPackage;

import static org.junit.Assert.*;

import java.sql.SQLException;

import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import windowsPackage.Search;
import windowsPackage.SearchString;

public class SearchStringTest {
	private SearchString searchString = new SearchString();

	@Test
	public void testSearchString() {
		fail("Not yet implemented");
	}
	
	@Test
	public void testGenerateBookingString() {
		//Finder alle bookinger, hvor afgangen er fra Billund
		try {
		assertEquals("BookingString", "SELECT * FROM `Booking` WHERE `TravelID` LIKE 2", 
				searchString.generateBookingString("Billund", "", "", "", "", "", "", ""));
		}
	catch(SQLException e2) {
		System.out.println(e2);
	}
		//Afgangen fra Billund ignoreres her, da TravelID er givet.
		try {
		assertEquals("BookingString", "SELECT * FROM `Booking` WHERE `BookingID` = 3 AND `TravelID` = 1",
				searchString.generateBookingString("Billund", "", "3", "1", "", "", "", ""));
				}
		catch(SQLException e2) {
			System.out.println(e2);
		}
	}

	@Test
	public void testGenerateCustomerString() {
		assertEquals("CustomerString", "SELECT * FROM `Customers` WHERE `CPR` LIKE '2202921111'", 
				searchString.generateCustomerString("","","2202921111", "", "", "", ""));
		assertEquals("CustomerString", "SELECT * FROM `Customers` WHERE `CPR` LIKE '2202921111' AND `Adress2` LIKE '6800 Varde'", 
				searchString.generateCustomerString("","","2202921111", "", "6800 Varde", "", ""));
	}

	@Test
	public void testGenerateTravelSearchString() {
		assertEquals("TravelString", "SELECT * FROM `Travel` ", searchString.generateTravelSearchString("", "", "", ""));
		assertEquals("TravelString", "SELECT * FROM `Travel` WHERE `To` LIKE 'Kbenhavn'", 
				searchString.generateTravelSearchString("", "", "", "Kbenhavn"));
		assertEquals("TravelString", "SELECT * FROM `Travel` WHERE `Departure` BETWEEN '2012-12-12 00:00:00' AND '2012-12-12 00:00:00'",
				searchString.generateTravelSearchString("2012-12-12 00:00:00", "", "", ""));
	}

	@Test
	public void testGenerateEditTravelSearchString() {
		assertEquals("EditTravelString", "SELECT * FROM `Travel` WHERE `TravelID` LIKE'1'",
				searchString.generateEditTravelSearchString("1", "", "", "", ""));
		assertEquals("EditTravelString", "SELECT * FROM `Travel` WHERE `TravelID` LIKE'1' AND `From` LIKE 'Billund'",
				searchString.generateEditTravelSearchString("1", "", "Billund", "", ""));
	}

}
