package windowsPackage;

import java.sql.ResultSet;
import java.sql.SQLException;

import javax.swing.JOptionPane;

public class SearchString {

	public SearchString() {
		
	}
	
	public String generateBookingString(String bookingFrom, String bookingTo, String bookingNr, String travelNr, String seatNr, String customerNr, String firstNameBooking, String lastNameBooking) throws SQLException {
		Database db = new Database();
		Integer tempTravelID = null;
		String cmd1 = "";
		String cmd = "SELECT * FROM `Booking` ";
		int i = 0;
		if(!bookingFrom.equals("")) {
			cmd1 += "SELECT * FROM `Travel` WHERE `From` LIKE '"+bookingFrom+"%'";
			i++;
		}
		if(!bookingTo.equals("")) {
			if(i == 0) {
				cmd1 += "SELECT * FROM `Travel` WHERE `To` LIKE '"+bookingTo+"%'";
			}
			else
				cmd1 += " AND `To` LIKE '"+bookingTo+"%'";
		}
		if(!cmd1.equals("")) {
			ResultSet temp = db.execute(cmd1);
			try {
				while(temp.next()) {
					tempTravelID = temp.getInt("TravelID");
				}
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		i = 0;
		if(!bookingNr.equals("")) {
			cmd += "WHERE `BookingID` = "+bookingNr;
			i++;
		}
		if(!travelNr.equals("")) {
			if(i == 0) {
				cmd += "WHERE `TravelID` = "+travelNr;
				i++;
			}
			else
				cmd += " AND `TravelID` = "+travelNr;
		}
		else if(!(tempTravelID == null)) {
			if(i == 0) {
				cmd += "WHERE `TravelID` LIKE " +tempTravelID;
				i++;
			}
			else 
				cmd += " AND `TravelID` LIKE " +tempTravelID;
		}
		if(!seatNr.equals("")) {
			if(i == 0) {
				cmd += "WHERE `SeatsID` LIKE '%"+seatNr+"%'";
				i++;
			}
			else
				cmd += " AND `SeatsID` LIKE '"+seatNr+"%'";
		}
		//Sg efter fornavn eller efternavn, hvis ikke kunde nr er udfyldt.
		String cmd2 = "";
		int k = 0; //
		if(!customerNr.equals("")) {
			if(i == 0) {
				cmd += "WHERE `CustomerID` LIKE "+customerNr;
				i++;
			}
			else
				cmd += " AND `CustomerID` LIKE "+customerNr;
		}
		else if(!firstNameBooking.equals("")) {
			cmd2 = "SELECT `CustomerID` FROM `Customers` WHERE `FirstName` LIKE '"+firstNameBooking+"%'";
			k++;
		}
		else if(!lastNameBooking.equals("")) {
			if(k == 0) {
				cmd2 = "SELECT `CustomerID` FROM `Customers` WHERE `LastName` LIKE '"+lastNameBooking+"%'";
			}
			else
				cmd2 += " AND `LastName` LIKE '"+lastNameBooking+"'";
		}
		if(!cmd2.equals("")) {
			ResultSet customerIDrs = db.execute(cmd2);
			int l = 0;
			while(customerIDrs.next()) {
				Integer tempCustomerID = customerIDrs.getInt("CustomerID");
				if(l == 0) {
					if(i == 0)
						cmd += "WHERE `CustomerID` = "+tempCustomerID;
					else {
						cmd += " AND `CustomerID` = "+tempCustomerID;
					}
				}
				else {
					cmd += " OR `CustomerID` = "+tempCustomerID;
				}
				l++;					
			}
		}

		return cmd;
	}
	public String generateCustomerString(String customerFirstName, String customerLastName, String customerCpr, String customerAdress, String customerCity, String customerPhoneNumber, String customerMail) {
		String cmd = "SELECT * FROM `Customers` ";
		int i = 0;
		if(!customerFirstName.equals("")) {
			cmd += "WHERE `FirstName` LIKE '" + customerFirstName + "%'";
			i++;
		}
		if(!customerLastName.equals("")) {
			if(i == 0) {
				cmd += "WHERE `LastName` LIKE '" + customerLastName + "%'";
				i++;
			} 
			else 
				cmd += " AND `LastName` LIKE '" + customerLastName + "%'";
		}
		if(!customerCpr.equals("")) {
			if(i == 0) {
				cmd += "WHERE `CPR` LIKE '" + customerCpr + "%'";
				i++;
			}
			else
				cmd += " AND `CPR` LIKE '" + customerCpr + "%'";
		}
		if(!customerAdress.equals("")) {
			if(i == 0) {
				cmd += "WHERE `Adress1` LIKE '" + customerAdress + "%'";
				i++;
			}
			else
				cmd += " AND `Adress1` LIKE '" + customerAdress + "%'";
		}
		if(!customerCity.equals("")) {
			if(i == 0) {
				cmd += "WHERE `Adress2` LIKE '" + customerCity + "%'";
				i++;
			}
			else
				cmd += " AND `Adress2` LIKE '" + customerCity + "%'";
		}
		if(!customerPhoneNumber.equals("")) {
			if(i == 0) {
				cmd += "WHERE `PhoneNumber` LIKE '" + customerPhoneNumber + "%'";
				i++;
			}
			else
				cmd += " AND `PhoneNumber` LIKE '" + customerPhoneNumber + "%'";
		}
		if(!customerMail.equals("")) {
			if(i == 0) {
				cmd += "WHERE `Mail` LIKE '" + customerMail + "%'";
				i++;
			}
			else 
				cmd += " AND `Mail` LIKE '" + customerMail + "%'";
		}
		return cmd;
	}
	
	public String generateTravelSearchString(String travelDeparture1, String travelDeparture2, String travelFrom, String travelTo ) {
		String cmd = "SELECT * FROM `Travel` ";
		int i = 0;
		
		if(travelDeparture1.equals("")  && !travelDeparture2.equals("")) {
			travelDeparture1 = travelDeparture2;
		}
		if(travelDeparture2.equals("")  && !travelDeparture1.equals("")) {
			travelDeparture2 = travelDeparture1;
		}
		
		if(!travelFrom.equals("")) {
			cmd += "WHERE `From` LIKE '" + travelFrom+"%'";
			i++;
		}
		if(!travelTo.equals("")) {
			if(i == 0) {
				cmd += "WHERE `To` LIKE '" + travelTo+"%'";
				i++;
			}
			else
				cmd += " AND `To` LIKE '" + travelTo+"%'";
		}
		if(!travelDeparture1.equals("")  && !travelDeparture2.equals("")) {
			if(i == 0) {
				cmd += "WHERE `Departure` BETWEEN '"+travelDeparture1+"' AND '" +travelDeparture2+"'";
			}
			else
				cmd += " AND `Departure` BETWEEN '"+travelDeparture1+"' AND '" +travelDeparture2+"'";
		}
		return cmd;
	}

	
	public String generateEditTravelSearchString(String editTravelTravelNumber, String editTravelFlightNumber, String editTravelFrom, String editTravelTo, String editTravelDeparture) {
		String cmd = "SELECT * FROM `Travel` ";
		int i = 0;
		
		if(!editTravelTravelNumber.equals("")) {
			cmd += "WHERE `TravelID` LIKE'" + editTravelTravelNumber +"'";
			i++;
		}
		if(!editTravelFlightNumber.equals("")) {
			if(i == 0) {
				cmd += "WHERE `AirPlaneID` LIKE '" + editTravelFlightNumber + "'";
				i++;
			}
			else
				cmd += " AND `AirPlaneID` LIKE '" + editTravelFlightNumber + "'";
		}
		if(!editTravelFrom.equals("")) {
			if(i == 0) {
				cmd += "WHERE `From` LIKE '"+ editTravelFrom + "%'";
				i++;
			}
			else
				cmd += " AND `From` LIKE '"+ editTravelFrom + "%'";
		}
		if(!editTravelTo.equals("")) {
			if(i == 0) {
				cmd += "WHERE `To` LIKE '" + editTravelTo + "%'";
			}
			else
				cmd += " AND `To` LIKE'" + editTravelTo +"%'";
		}
		if(!editTravelDeparture.equals("")) {
			if(i == 0) {
				cmd += "WHERE `Departure` LIKE'" + editTravelDeparture + " 00:00:00'";
			}
			else
				cmd += " AND `Departure` LIKE'" + editTravelDeparture + " 00:00:00'";
		}
		return cmd;
	}
}
